Rem
Rem ----------------------------------------------
Rem 
Rem   Installation of Lighty ASH 
Rem   (Tool to simulate the ASH Feature)
Rem
Rem   L-ASH - V1.0 
Rem   01/03/2014 - Creation
Rem 
Rem                            www.orachrome.com
Rem ----------------------------------------------
Rem


prompt
prompt installation of L-ASH V1.0
prompt  
prompt                    www.orachrome.com 
prompt ------------------------------------  

set echo off verify off showmode off feedback off; 
whenever sqlerror exit sql.sqlcode
col username new_value username
set term off

SELECT SYS_CONTEXT ('USERENV', 'SESSION_USER') username
   FROM DUAL;

set term on

begin
if '&username' <>  'SYS'  then
    raise_application_error(-20101, 'Install failed - you muste be connected as SYSDBA');
  end if;
end;
/

prompt
prompt Choose ASHSTAT user's password
prompt ------------------------------------  

prompt &&ashstat_pwd

begin
  if '&&ashstat_pwd' is null then
    raise_application_error(-20101, 'Install failed - No password specified');
  end if;
end;
/

prompt
prompt Choose the Default tablespace for the ASHSTAT user
prompt ----------------------------------------------------

prompt &&default_tablespace

set heading off
begin
  if '&&default_tablespace' is null then
    raise_application_error(-20101, 'Install failed - No Tablespace specified');
  end if;
end;
/

prompt
prompt
prompt ... Creating ASHSTAT user

create user ashstat 
  identified by &&ashstat_pwd
  default tablespace &&default_tablespace;

alter user ASHSTAT quota unlimited on &&default_tablespace;

prompt
prompt
prompt ... Installing required packages


grant create session to ashstat;
grant create table to ashstat;
grant create procedure to ashstat;
grant create job to ashstat;
grant select on gv_$session to ashstat;
grant select on v_$bgprocess to ashstat;
grant select on gv_$sql to ashstat;
grant select on dba_services to ashstat;


whenever sqlerror continue;
set echo on feedback on;

alter session set current_schema=ASHSTAT;

set echo off feedback on;
prompt 
prompt ... Create table L_ASH

@l_ash_table.sql
prompt 
prompt ... Create Package Lighty_pkg
@l_pkg.sql
prompt 
prompt ... Create Scheduler jobs "L-ASH" and "PURGE L-ASH"
@l_job.sql
prompt 
prompt ... View Scheduler jobs "L-ASH" and "PURGE L-ASH"
@l_job_state.sql

undef username
undef ashstat_pwd
undef default_tablespace
